﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;Script control (VBS) demo. 
;*
;*We show how a VBS script can be made to call a PB function.
;*
;*Note that whilst we include error trapping you can instead use an event-handler to catch all errors etc.
;/////////////////////////////////////////////////////////////////////////////////


IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"


;The following include contains a helper function.
  IncludeFile "VBS_Call PB function_INCLUDE.pbi"


;Our VB test script.
  code$ = "Function SumIntegers(ByVal a, ByVal b)" + #CRLF$
  code$ + "SumIntegers = a + b" + #CRLF$
  ;The following VBS line will invoke our event handler with two parameters; 1 string and 1 integer.
    code$ + "InvokePB.OurEvents " + Chr(34) + "SumIntegers() finished execution..." + Chr(34) + ", 10" + #CRLF$
  code$ + "End Function" + #CRLF$


Declare scriptCallback(numParams, Array args$(1))


Define.COMateObject scriptObject, errorObject
scriptObject = COMate_CreateObject("MSScriptControl.ScriptControl.1") 
If scriptObject
  scriptObject\SetProperty("Language = 'VBScript'")
  ;The following call to our helper function adds our COM object to the VB script.
    CreateAddinObject(scriptObject, "OurEvents", @scriptCallback())
  ;Now continue as normal.
  If scriptObject\Invoke("AddCode('" + code$ + "')") = #S_OK
    result = scriptObject\GetIntegerProperty("Eval('SumIntegers(10, 20)')")
    MessageRequester("Script demo", Chr(34) + code$ + Chr(34) + #LF$ + #LF$ + "Produced a result of : " + Str(result))
  Else
    errorObject = scriptObject\GetObjectProperty("Error")
    If errorObject  
      MessageRequester("Script demo - error reported!", Chr(34) + errorObject\GetStringProperty("Text") + Chr(34) + #LF$ + " produced the following error : " + #LF$ + #LF$ + errorObject\GetStringProperty("Description"))
      errorObject\Release()
    EndIf
  EndIf
  scriptObject\Release()
Else
  MessageRequester("COMate - Scripting demo", "Couldn't create the scripting object!")
EndIf



;-Event handler (called from our VB script!)
Procedure scriptCallback(numParams, Array args$(1))
  Protected i
  Debug "Our VBS has called this function with " + Str(numParams) + " parameter(s) as follows : "
  For i = 1 To numParams
    Debug "    '" + args$(i-1) + "'"    
  Next
EndProcedure



; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 36
; FirstLine = 16
; Folding = -
; EnableUnicode
; Executable = nxReportU.dll