﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;FlexCell.Grid demo (with events!) - thanks to Terence Agius.
;http://www.grid2000.com/ for FlexCell.
;
;This demo shows how ActiveX controls often pass parameters to event handlers by reference,
;thus allowing you to modify their values etc. In this case we prevent the user from selecting cell (2, 1).
;We also use an individual event handler as opposed to a 'global' one.
;/////////////////////////////////////////////////////////////////////////////////

XIncludeFile "flexcell.pbi"
IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"


Define.COMateObject iGrid, iGridObj

;/////////////////////////////////////////////////////////////////////////////////
;The following is our ActiveX event handler for the "LeaveCell" event.
;This is where we arrange for the user to not be able to select cell (2, 1)
Procedure LeaveCell_Handler(FlexObject.COMateObject, eventName$, parameterCount)
  Protected *ptrBoolean.WORD, newRow, newColumn
  ;Is the user trying to select cell (2, 1) ?
    newRow = FlexObject\GetIntegerEventParam(3)
    newColumn = FlexObject\GetIntegerEventParam(4)
    If newRow = 2 And newColumn = 1
      ;Get the address of the final parameter which is a boolean passed by reference.
        FlexObject\IsEventParamPassedByRef(5, @*ptrBoolean)
      ;Set the boolean to true to prohibit the selection.
        *ptrBoolean\w = #VARIANT_TRUE
    EndIf
EndProcedure
;/////////////////////////////////////////////////////////////////////////////////


If OpenWindow(0, 0, 0, 800, 800, "COMate - FlexCell demo", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)

  iGrid = COMate_CreateActiveXControl(30, 30, 740, 740, "FlexCell.Grid")
  
  If Not iGrid 
    If COMate_RegisterCOMServer("FlexCell.ocx") = #S_OK
      blnRegister = #True
      iGrid = COMate_CreateActiveXControl(30, 30, 740, 740, "FlexCell.Grid")
    EndIf  
  EndIf

  If iGrid
    iGrid\Invoke( "AboutBox()" )
    iGrid\SetProperty("Cols = 12")
    iGrid\SetProperty("Rows = 100")
    iGrid\SetProperty("AutoRedraw = #True")
    iGrid\SetProperty("SelectionMode = 3")
    iGrid\SetProperty("Cell(2,1)\Text = 'Try and select me!'")
    iGrid\SetProperty("Column(1)\Width = 250" )
    iGrid\Invoke("Range(1,1,1,1)\Selected")

    ;Set up an event handler for just a single event (the 'LeaveCell' event).
      iGrid\SetEventHandler("LeaveCell", @LeaveCell_Handler())

    Repeat
      Select WaitWindowEvent()
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    ForEver
    iGrid\Release()
  Else
    MessageRequester("COMate - FlexCell ActiveX demo", "Couldn't create the ActiveX control!")
  EndIf
  
  If blnRegister
    COMate_UnRegisterCOMServer( "FlexCell.ocx" )
  EndIf
EndIf




; IDE Options = PureBasic 4.61 Beta 1 (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableUnicode
; EnableXP